# MKDocs Uploader
# Written by Peter Killert, www.killert.de
# Version 1.1, January 2024

# Documentation and Description : https://www.killert.de/blog

# Free for Non-commercial use

def loop_through_directories_all():
       
    import os.path
    import datetime
    from datetime import datetime
    global project_folder
    global site_folder
    global exclude_dirs
    global exclude_files
    global build_include
    global build_dirty
    global new_images_only

    target_array = [] 
    directory_array = []   
    file_counter = 0
    file_counter_sorted = 0

    print("Folder to maintain: " + project_folder)
    print("Documents located in subfolder: " + site_folder)
    print("Checking site folder")
    print("")
    print("Getting directories and files for upload ... please wait.")


    # Get The Files
    directory = os.path.join(project_folder, site_folder)
    for subdir, dirs, files in os.walk(directory):
        [dirs.remove(d) for d in list(dirs) if d in exclude_dirs]
        for file in files:
            if file not in exclude_files:
                file_path = os.path.join(subdir, file)
                position_of_docs_folder = file_path.find(site_folder)
                docs_folder_length = len(site_folder)
                level_1_start = position_of_docs_folder + docs_folder_length + 1
                folder_level_1 = file_path[level_1_start:]
                Level_1_Array = folder_level_1.split('\\')
                Level_1_Array_Length = len(Level_1_Array)
                y = 0
                Level_2_Target = ""

                for x in Level_1_Array:
                    if y < Level_1_Array_Length:
                        Level_2_Target = Level_2_Target + "/" + str(x)

                the_date = datetime.today().strftime('%Y-%m-%d')
                time_created = datetime.fromtimestamp(os.path.getmtime(file_path)).strftime('%Y-%m-%dT%H:%M:%S')

                # Add result to target Array
                               
                if build_include == 'true' and build_dirty == 'true':
                    if the_date[:10] == time_created[:10]:
                        directory_array.append(Level_2_Target) 
                        target_array.append(Level_2_Target)                
                        file_counter = file_counter + 1
                    else:
                        file_counter_sorted = file_counter_sorted+1
                else:
                    if new_images_only == 'true':
                        if Level_2_Target.endswith(".jpg") or Level_2_Target.endswith(".png") or Level_2_Target.endswith(".gif"):
                            if the_date[:10] == time_created[:10]:
                                directory_array.append(Level_2_Target) 
                                target_array.append(Level_2_Target)                                
                                file_counter = file_counter + 1
                        else:
                            directory_array.append(Level_2_Target) 
                            target_array.append(Level_2_Target)                                
                            file_counter = file_counter + 1
                    else:
                        directory_array.append(Level_2_Target) 
                        target_array.append(Level_2_Target)                                
                        file_counter = file_counter + 1
                    
    # Upload The Files
    print("Preparation ready : " +  str(file_counter) + " Files will be uploaded. " + str(file_counter_sorted) + " sorted out as unchanged. Please wait.")                    
    upload_files(target_array, directory_array)



def upload_files(target_array, directory_array):

    import codecs
    import subprocess

    global upload_domain
    global upload_user
    global upload_pass
    global upload_directory
    global win_scp_path
    global always_load_assets
    

    # Get Build ("Site") directory
    global project_folder
    the_source_folder = project_folder + "\\site"

    host = upload_domain
    username = upload_user
    password = upload_pass
    the_directory = upload_directory

    # Delete old Script File
    if os.path.isfile("ftp_process.txt") == True:
        os.remove("ftp_process.txt")

    with codecs.open('ftp_process.txt', 'w',  "utf-8") as f:

        f.write('option batch on\n')
        f.write('option confirm off\n')
        f.write('open sftp://'+upload_user + ':' + upload_pass  + "@" + upload_domain + "\n")

        SingleSubDirStr = ''

        for TheDirectories in directory_array:
            # Split the Directory Array and create each single subdirectory
            SingleDirArray = TheDirectories.split('/')

            for SingleSubDir in SingleDirArray:
                f.write('option batch continue\n')
                SingleSubDirStr = SingleSubDirStr + SingleSubDir + '/'
                f.write('mkdir ' + upload_directory + SingleSubDirStr +'\n')

            SingleSubDirStr = ''

        for TheFiles in target_array:
            file_to_load = the_source_folder + TheFiles
            file_to_load_path = os.path.normpath(file_to_load)
            #print("File To Load: " + file_to_load_path)
            # f.write("Source: " + file_to_load_path + "\n")
            target_file = upload_directory + TheFiles
            target_file_path = target_file.replace("\\", "/")
            target_file_path = target_file_path.replace("index.html", "")
            #print("Target File: " + target_file_path)
            f.write('put "' + file_to_load_path + '" "' + target_file_path + '"\n')

        # Complete Assets copy:
        if always_load_assets == 'true':
            f.write('put "' + the_source_folder + '\\assets "' + upload_directory + '/assets/"\n')
            f.write('put "' + the_source_folder + '\\assets\javascripts "' + upload_directory + '/assets/"\n')
            f.write('put "' + the_source_folder + '\\assets\images "' + upload_directory + '/assets/"\n')
            f.write('put "' + the_source_folder + '\\assets\stylesheets "' + upload_directory + '/assets/"\n')

        # Index and Sitemaps
        f.write('put "' + the_source_folder + '\\index.html "' + upload_directory + '/index.html"\n')
        f.write('put "' + the_source_folder + '\\sitemap.xml "' + upload_directory + '/sitemap.xml"\n')        
        f.write("exit")

    # Call the Script
    cwd = os.getcwd()
    script_path = win_scp_path
    script_path = script_path.replace("/", "\\")
    script_path = script_path.replace(" ", "\u0020")
    script_path = script_path + " /script=ftp_process.txt"  
    print("Upload has started ... please wait ...")  
    subprocess.call(script_path)
  
def load_config():
    import yaml
    with open('mkdocsuploader_config.yml',encoding="utf-8_sig") as f:

        data = yaml.load(f, Loader=yaml.FullLoader)
        
        global project_folder
        global docs_folder
        global site_folder
        global win_scp_path
        global upload_domain
        global upload_directory
        global upload_user
        global upload_pass
        global exclude_dirs
        global exclude_files
        global build_include
        global build_dirty
        global always_load_assets
        global no_upload
        global build_quiet
        global new_images_only

        
        config = data["config"]
        
        project_folder = config["project_folder"]
        docs_folder = config["docs_folder"]
        site_folder = config["site_folder"]
        win_scp_path = config["win_scp_path"]
        upload_domain = config["upload_domain"]
        upload_directory = config["upload_directory"]
        upload_user = config["upload_user"]
        upload_pass = config["upload_pass"]
        exclude_dirs = config["exclude_dirs"]
        exclude_files = config["exclude_files"]
        build_include = config["build_include"]
        build_dirty = config["build_dirty"]
        always_load_assets = config["always_load_assets"]
        no_upload = config["no_upload"]
        build_quiet = config["build_quiet"]
        new_images_only = config["new_images_only"]

        print("Configuration loaded successfully.")

# Hauptprogramm
import os
import subprocess

build_exec_path = ''
clear = lambda: os.system('cls')
clear()
print('Starting MKDocsUploader, Version 1.10, (c) www.killert.de | Peter Killert')
load_config()

# Switch to project folder
current_folder = os.getcwd()
os.chdir(project_folder)

# Create a Build first?
if build_include == 'true':
    if build_dirty == 'true':  
        if build_quiet == 'true'      :
            print("Performing Dirty and Quiet Build ... please wait ...")
            subprocess.call("mkdocs build --dirty --quiet")            
        else:
            print("Performing Dirty Build ... please wait ...")
            subprocess.call("mkdocs build --dirty")            
    else:
        if build_quiet == 'true':
            print("Performing Full Build ... please wait ...")
            subprocess.call("mkdocs build")
        else:
            print("Performing Full Build in Quiet Mode ... please wait ...")
            subprocess.call("mkdocs build --quiet")
else:
    print("No Build process selected")

if no_upload != 'true':
    loop_through_directories_all() 
else:
    print("Script was set to : No upload.")

print("")
print("All done. Have fun.")
print("")


#Clean up
# Delete old Script File
if os.path.isfile("ftp_process.txt") == True:
    os.remove("ftp_process.txt")